/*
  ----------------------------------------------------------------------
  NOME: 
  CONGNOME: 
  MATRICOLA: 
  CODICE CALCOLATORE: 
  ----------------------------------------------------------------------
*/

#include <iostream>
#include <cstdlib>
#include <assert.h>

using namespace std;

/* --------------------------- INIZIO PUNTO 1  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */


// Singolo messaggio
struct Messaggio {
	//...
};


// Lista di messaggi

// Coda di messaggi

// Server
struct Server {
	const char* nome;
	//...
};



/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 1  -------------------------- */



/* --------------------------- INIZIO PUNTO 2  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

/** Stampa il messaggio passato.
		se stampa_testo e' false, non stampa il testo del messaggio. 
		Formato richiesto:
Da <mitt> per <dest>: <testo>\n

    Se stampa_testo e' true, altimenti:
Da <mitt> per <dest>\n

   Ad esempio:
Da 123 a 321: Ciao!

   Notare il newline alla fine della riga. 
 */
void Messaggio_stampa(const Messaggio &msg, bool stampa_testo=true) 
{
	// ...
}


/** Stampa la lista di messaggi. Ogni messaggio su una riga diversa.
		Ad esempio:
Da 123 a 321: Ciao!
Da 321 a 123: Com'e' andato l'esame?
Da 123 a 321: Bene grazie!
 */
void ListaMsg_stampa(/* ... */)
{
}

/** Stampa la coda di messaggi, in qualsiasi ordine si desideri. 
    Il formato e':
Ci sono <len> messaggi in coda:
<msg1>
<msg2>
...
<msgN>

   Se stampa_messagi e' true e la coda non e' vuota, altrimenti:
Ci sono <len> messaggi in coda

   Si noti il newline alla fine. 
*/
void CodaMsg_stampa(const CodaMsg &coda, bool stampa_messaggi)
{
	// ...
}

/** Stampa informazioni sul server. 
		Il formato e':
Server <nome>: 
Da fibra: <coda da_fibra>
A fibra: <coda a_fibra>

   Il parametro stampa_messaggi deve essere passato a CodaMsg_stampa. 
*/
void Server_stampa(/* ... ,*/ bool stampa_messaggi)
{
	// ...
}


/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 2 -------------------------- */



/* --------------------------- INIZIO PUNTO 3  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
void CodaMsg_push(CodaMsg &coda, const Messaggio &msg)
{
	// ...
}


/* ... */ CodaMsg_pop(/*... */)
{

}


/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 3 -------------------------- */



/* --------------------------- INIZIO PUNTO 4  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */


/** Riceve dall'antenna un messaggio */
void Server_ricevi_da_antenna(Server &server, const Messaggio &msg)
{
	// ...
}


/** Rimuove un messaggio dalla coda da_fibra, e lo invia
		all'antenna. Stampa un testo */
void Server_invia_ad_antenna(/* ... */)
{
	// ...
}

/** Riceve un messagio dalla fibra */
void Server_ricevi_da_fibra(/* ... */)
{
}

/** Rimuove un messaggio dalla coda a_fibra, e restituisce il
		messaggio inviato. Stampa un testo. */
/* ... */ Server_invia_a_fibra(/* ... */)
{
	// ...
}



/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 4 -------------------------- */



// ----------------------------------------------------------------------
// Main del programma
// ----------------------------------------------------------------------

int main() 
{
	// i due server
	Server s1("Trento");
	Server s2("Verona");

	// 3 messaggi
	Messaggio messaggi[] = {
		Messaggio("Taca la pasta che 'rivo", 123, 321),
		Messaggio("Vaben, te 'speto!", 321, 123), 
		Messaggio("Ciao", 321, 213)
	};

	// 3 cellulari mandano un messaggio
	for (int i=0; i<(sizeof(messaggi)/sizeof(messaggi[0])); ++i) {
		Server_ricevi_da_antenna(s1, messaggi[i]);		
	}


	// Stampa server s1 e s2:
	Server_stampa(s1, true);
	cout << endl;
	Server_stampa(s2, true);

	// invia i messaggi sulla fibra, e trasferisci sul server s2
	for (int i=0; i<(sizeof(messaggi)/sizeof(messaggi[0])); ++i) {
		Messaggio msg = Server_invia_a_fibra(s1);
		Server_ricevi_da_fibra(s2, msg); // trasferisci a s2
	}

	// Stampa server s1 e s2:
	cout << endl;
	Server_stampa(s1, true);
	cout << endl;
	Server_stampa(s2, true);


	// trasferisci da s2 all'antenna
	for (int i=0; i<(sizeof(messaggi)/sizeof(messaggi[0])); ++i) {
		Server_invia_ad_antenna(s2);
	}
	

	// Stampa server s1 e s2:
	cout << endl;
	Server_stampa(s1, true);
	cout << endl;
	Server_stampa(s2, true);

  return 0;
}
